diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/schedules/tests/test_pgagent_add_schedule.py b/web/pgadmin/browser/server_groups/servers/pgagent/schedules/tests/test_pgagent_add_schedule.py
new file mode 100644
index 000000000..1465b1a0c
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/schedules/tests/test_pgagent_add_schedule.py
@@ -0,0 +1,81 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+from unittest.mock import patch
+import simplejson as json
+import uuid
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from pgadmin.browser.server_groups.servers.pgagent.tests import utils as \
+    pgagent_utils
+from . import utils as schedules_utils
+
+
+class PgAgentAddScheduleTestCase(BaseTestGenerator):
+    """This class will test the add schedule in the pgAgent job API"""
+    scenarios = utils.generate_scenarios("pgagent_create_schedule",
+                                         schedules_utils.test_cases)
+
+    def setUp(self):
+        flag, msg = pgagent_utils.is_valid_server_to_run_pgagent(self)
+        if not flag:
+            self.skipTest(msg)
+        flag, msg = pgagent_utils.is_pgagent_installed_on_server(self)
+        if not flag:
+            self.skipTest(msg)
+
+        # Load test data
+        self.data = self.test_data
+
+        # Create a test job
+        name = "test_job_get%s" % str(uuid.uuid4())[1:8]
+        self.job_id = pgagent_utils.create_pgagent_job(self, name)
+
+    def runTest(self):
+        # Check and Delete entry for pga_exception table for the above
+        # date and time as no primary key is defined for pga_exception table
+        # and there is a unique constraint for date and time. So when we run
+        # the test cases multiple time then it will fail with unique
+        # constraint error.
+        if 'jscexceptions' in self.data:
+            jexdate = self.data['jscexceptions'][0]["jexdate"]
+            jextime = self.data['jscexceptions'][0]["jextime"]
+            pgagent_utils.delete_pgagent_exception(self, jexdate, jextime)
+
+        self.pgagent_schedule_name = "test_sch_add%s" % str(uuid.uuid4())[1:8]
+
+        if "jscjobid" in self.data:
+            self.data["jscjobid"] = self.job_id
+            self.data["jscname"] = self.pgagent_schedule_name
+
+        if self.is_positive_test:
+            response = schedules_utils.api_create(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+
+            # Verify in backend
+            response_data = json.loads(response.data)
+            self.schedule_id = response_data['node']['_id']
+            is_present = pgagent_utils.verify_pgagent_schedule(self)
+            self.assertTrue(is_present,
+                            "pgAgent schedule was not created successfully.")
+
+        else:
+            if self.mocking_required:
+                with patch(self.mock_data["function_name"],
+                           side_effect=eval(self.mock_data["return_value"])):
+                    response = schedules_utils.api_create(self)
+
+                    # Assert response
+                    utils.assert_status_code(self, response)
+                    utils.assert_error_message(self, response)
+
+    def tearDown(self):
+        """Clean up code"""
+        pgagent_utils.delete_pgagent_job(self)
diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/tests/tests_pgagent_delete_schedule.py b/web/pgadmin/browser/server_groups/servers/pgagent/schedules/tests/test_pgagent_delete_schedule.py
similarity index 60%
rename from web/pgadmin/browser/server_groups/servers/pgagent/tests/tests_pgagent_delete_schedule.py
rename to web/pgadmin/browser/server_groups/servers/pgagent/schedules/tests/test_pgagent_delete_schedule.py
index dbbc16105..b30fffd59 100644
--- a/web/pgadmin/browser/server_groups/servers/pgagent/tests/tests_pgagent_delete_schedule.py
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/schedules/tests/test_pgagent_delete_schedule.py
@@ -10,14 +10,15 @@
 import uuid
 from pgadmin.utils.route import BaseTestGenerator
 from regression.python_test_utils import test_utils as utils
-from . import utils as pgagent_utils
+from pgadmin.browser.server_groups.servers.pgagent.tests import utils as\
+    pgagent_utils
+from . import utils as schedules_utils
 
 
 class PgAgentDeleteScheduleTestCase(BaseTestGenerator):
     """This class will test the delete pgAgent job schedule API"""
-    scenarios = [
-        ('Delete pgAgent Schedule', dict(url='/browser/pga_schedule/obj/'))
-    ]
+    scenarios = utils.generate_scenarios("pgagent_delete_schedule",
+                                         schedules_utils.test_cases)
 
     def setUp(self):
         flag, msg = pgagent_utils.is_valid_server_to_run_pgagent(self)
@@ -26,26 +27,38 @@ class PgAgentDeleteScheduleTestCase(BaseTestGenerator):
         flag, msg = pgagent_utils.is_pgagent_installed_on_server(self)
         if not flag:
             self.skipTest(msg)
+
+        # Load test data
+        self.data = self.test_data
+
         name = "test_job_delete%s" % str(uuid.uuid4())[1:8]
         self.job_id = pgagent_utils.create_pgagent_job(self, name)
+
         sch_name = "test_schedule_delete%s" % str(uuid.uuid4())[1:8]
         self.schedule_id = pgagent_utils.create_pgagent_schedule(
             self, sch_name, self.job_id)
 
+        # multiple schedules
+        if self.is_list:
+            sch_name2 = "test_schedule_delete%s" % str(uuid.uuid4())[1:8]
+            self.schedule_id_2 = pgagent_utils.create_pgagent_schedule(
+                self, sch_name2, self.job_id)
+
     def runTest(self):
         """This function will deletes pgAgent job schedule"""
-        response = self.tester.delete(
-            '{0}{1}/{2}/{3}/{4}'.format(
-                self.url, str(utils.SERVER_GROUP), str(self.server_id),
-                str(self.job_id), str(self.schedule_id)
-            ),
-            content_type='html/json'
-        )
-        self.assertEqual(response.status_code, 200)
+        if self.is_positive_test:
+            if self.is_list:
+                self.data['ids'] = [self.schedule_id, self.schedule_id_2]
+                response = schedules_utils.api_delete(self, '')
+            else:
+                response = schedules_utils.api_delete(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+
         is_present = pgagent_utils.verify_pgagent_schedule(self)
         self.assertFalse(
-            is_present, "pgAgent schedule was not deleted successfully"
-        )
+            is_present, "pgAgent schedule was not deleted successfully")
 
     def tearDown(self):
         """Clean up code"""
diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/schedules/tests/test_pgagent_get_msql_schedule.py b/web/pgadmin/browser/server_groups/servers/pgagent/schedules/tests/test_pgagent_get_msql_schedule.py
new file mode 100644
index 000000000..fba6f2061
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/schedules/tests/test_pgagent_get_msql_schedule.py
@@ -0,0 +1,68 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import uuid
+
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from pgadmin.browser.server_groups.servers.pgagent.tests import utils as \
+    pgagent_utils
+from . import utils as schedules_utils
+
+
+class PgAgentGetMsqlScheduleTestCase(BaseTestGenerator):
+    """This class will test the msql pgAgent job schedule API"""
+    scenarios = utils.generate_scenarios("pgagent_msql_schedule",
+                                         schedules_utils.test_cases)
+
+    def setUp(self):
+        flag, msg = pgagent_utils.is_valid_server_to_run_pgagent(self)
+        if not flag:
+            self.skipTest(msg)
+        flag, msg = pgagent_utils.is_pgagent_installed_on_server(self)
+        if not flag:
+            self.skipTest(msg)
+
+        # Load test data
+        self.data = self.test_data
+
+        name = "test_job_msql%s" % str(uuid.uuid4())[1:8]
+        self.job_id = pgagent_utils.create_pgagent_job(self, name)
+
+        sch_name = "test_schedule_msql%s" % str(uuid.uuid4())[1:8]
+        self.schedule_id = pgagent_utils.create_pgagent_schedule(
+            self, sch_name, self.job_id)
+
+        if self.is_list:
+            sch_name2 = "test_schedule_msql%s" % str(uuid.uuid4())[1:8]
+            self.schedule_id_2 = pgagent_utils.create_pgagent_schedule(
+                self, sch_name2, self.job_id)
+
+    def runTest(self):
+        """This function will get pgAgent msql job schedule"""
+        if self.is_positive_test:
+            url_encode_data = self.data
+            if self.is_list:
+                self.data["jschedules"]["changed"][0]["jscid"] = \
+                    self.schedule_id
+                self.data["jschedules"]["changed"][1]["jscid"] = \
+                    self.schedule_id_2
+                url_encode_data["jobid"] = self.job_id
+                response = schedules_utils.\
+                    api_get_msql(self, url_encode_data, '')
+            else:
+                url_encode_data["jscid"] = self.schedule_id
+                response = schedules_utils.api_get_msql(self, url_encode_data)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+
+    def tearDown(self):
+        """Clean up code"""
+        pgagent_utils.delete_pgagent_job(self)
diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/schedules/tests/test_pgagent_get_nodes_schedule.py b/web/pgadmin/browser/server_groups/servers/pgagent/schedules/tests/test_pgagent_get_nodes_schedule.py
new file mode 100644
index 000000000..d5e3c5363
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/schedules/tests/test_pgagent_get_nodes_schedule.py
@@ -0,0 +1,70 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import uuid
+from unittest.mock import patch
+
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from pgadmin.browser.server_groups.servers.pgagent.tests import utils as\
+    pgagent_utils
+from . import utils as schedules_utils
+
+
+class PgAgentGetNodesScheduleTestCase(BaseTestGenerator):
+    """This class will test the get nodes pgAgent job schedule API"""
+    scenarios = utils.generate_scenarios("pgagent_get_nodes_schedule",
+                                         schedules_utils.test_cases)
+
+    def setUp(self):
+        flag, msg = pgagent_utils.is_valid_server_to_run_pgagent(self)
+        if not flag:
+            self.skipTest(msg)
+        flag, msg = pgagent_utils.is_pgagent_installed_on_server(self)
+        if not flag:
+            self.skipTest(msg)
+
+        # Load test data
+        self.data = self.test_data
+
+        name = "test_job_get_nodes%s" % str(uuid.uuid4())[1:8]
+        self.job_id = pgagent_utils.create_pgagent_job(self, name)
+
+        sch_name = "test_schedule_get_nodes%s" % str(uuid.uuid4())[1:8]
+        self.schedule_id = pgagent_utils.create_pgagent_schedule(
+            self, sch_name, self.job_id)
+
+        if self.is_list:
+            sch_name2 = "test_schedule_get_nodes%s" % str(uuid.uuid4())[1:8]
+            self.schedule_id_2 = pgagent_utils.create_pgagent_schedule(
+                self, sch_name2, self.job_id)
+
+    def runTest(self):
+        """This function will gets pgAgent job schedule"""
+        if self.is_positive_test:
+            if self.is_list:
+                response = schedules_utils.api_get(self, '')
+            else:
+                response = schedules_utils.api_get(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+        else:
+            if self.mocking_required:
+                with patch(self.mock_data["function_name"],
+                           side_effect=[eval(self.mock_data["return_value"])]):
+                    response = schedules_utils.api_get(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+            utils.assert_error_message(self, response)
+
+    def tearDown(self):
+        """Clean up code"""
+        pgagent_utils.delete_pgagent_job(self)
diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/schedules/tests/test_pgagent_get_schedule.py b/web/pgadmin/browser/server_groups/servers/pgagent/schedules/tests/test_pgagent_get_schedule.py
new file mode 100644
index 000000000..06f73c217
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/schedules/tests/test_pgagent_get_schedule.py
@@ -0,0 +1,70 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import uuid
+from unittest.mock import patch
+
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from pgadmin.browser.server_groups.servers.pgagent.tests import utils as\
+    pgagent_utils
+from . import utils as schedules_utils
+
+
+class PgAgentGetScheduleTestCase(BaseTestGenerator):
+    """This class will test the get pgAgent job schedule API"""
+    scenarios = utils.generate_scenarios("pgagent_get_schedule",
+                                         schedules_utils.test_cases)
+
+    def setUp(self):
+        flag, msg = pgagent_utils.is_valid_server_to_run_pgagent(self)
+        if not flag:
+            self.skipTest(msg)
+        flag, msg = pgagent_utils.is_pgagent_installed_on_server(self)
+        if not flag:
+            self.skipTest(msg)
+
+        # Load test data
+        self.data = self.test_data
+
+        name = "test_job_get%s" % str(uuid.uuid4())[1:8]
+        self.job_id = pgagent_utils.create_pgagent_job(self, name)
+
+        sch_name = "test_schedule_get%s" % str(uuid.uuid4())[1:8]
+        self.schedule_id = pgagent_utils.create_pgagent_schedule(
+            self, sch_name, self.job_id)
+
+        if self.is_list:
+            sch_name2 = "test_schedule_get%s" % str(uuid.uuid4())[1:8]
+            self.schedule_id_2 = pgagent_utils.create_pgagent_schedule(
+                self, sch_name2, self.job_id)
+
+    def runTest(self):
+        """This function will gets pgAgent job schedule"""
+        if self.is_positive_test:
+            if self.is_list:
+                response = schedules_utils.api_get(self, '')
+            else:
+                response = schedules_utils.api_get(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+        else:
+            if self.mocking_required:
+                with patch(self.mock_data["function_name"],
+                           side_effect=[eval(self.mock_data["return_value"])]):
+                    response = schedules_utils.api_get(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+            utils.assert_error_message(self, response)
+
+    def tearDown(self):
+        """Clean up code"""
+        pgagent_utils.delete_pgagent_job(self)
diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/schedules/tests/test_pgagent_put_schedule.py b/web/pgadmin/browser/server_groups/servers/pgagent/schedules/tests/test_pgagent_put_schedule.py
new file mode 100644
index 000000000..cc5fc87ad
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/schedules/tests/test_pgagent_put_schedule.py
@@ -0,0 +1,94 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+
+import uuid
+from unittest.mock import patch
+
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from pgadmin.browser.server_groups.servers.pgagent.tests import utils as \
+    pgagent_utils
+from . import utils as schedules_utils
+
+
+class PgAgentPutScheduleTestCase(BaseTestGenerator):
+    """This class will test the update pgAgent schedule API"""
+    # Generates scenarios
+    scenarios = utils.generate_scenarios("pgagent_put_schedule",
+                                         schedules_utils.test_cases)
+
+    def setUp(self):
+        flag, msg = pgagent_utils.is_valid_server_to_run_pgagent(self)
+        if not flag:
+            self.skipTest(msg)
+        flag, msg = pgagent_utils.is_pgagent_installed_on_server(self)
+        if not flag:
+            self.skipTest(msg)
+
+        # Load test data
+        self.data = self.test_data
+
+        name = "test_job_update%s" % str(uuid.uuid4())[1:8]
+        self.job_id = pgagent_utils.create_pgagent_job(self, name)
+
+        sch_name = "test_schedule_update%s" % str(uuid.uuid4())[1:8]
+        self.schedule_id = pgagent_utils.create_pgagent_schedule(
+            self, sch_name, self.job_id)
+
+    def runTest(self):
+        """This function will update pgAgent schedule"""
+
+        # Check and Delete entry for pga_exception table for the specified
+        # date and time as no primary key is defined for pga_exception table
+        # and there is a unique constraint for date and time. So when we run
+        # the test cases multiple time then it will fail with unique
+        # constraint error.
+        if 'jscexceptions' in self.data:
+            exception_data = self.data['jscexceptions']
+            if 'added' in exception_data:
+                pgagent_utils.delete_pgagent_exception(
+                    self, self.data['jscexceptions']['added'][0]['jexdate'],
+                    self.data['jscexceptions']['added'][0]['jextime'])
+            elif 'changed' in exception_data:
+                date = self.data['jscexceptions']['changed'][0]['jexdate']
+                time = self.data['jscexceptions']['changed'][0]['jextime']
+                self.excp_id = pgagent_utils.create_pgagent_exception(
+                    self, self.schedule_id, date, time)
+                self.data['jscexceptions']['changed'][0]['jexid'] = \
+                    self.excp_id
+
+            elif 'deleted' in exception_data:
+                date = self.data['jscexceptions']['deleted'][0]['jexdate']
+                time = self.data['jscexceptions']['deleted'][0]['jextime']
+                self.excp_id = pgagent_utils.create_pgagent_exception(
+                    self, self.schedule_id, date, time)
+                self.data['jscexceptions']['deleted'][0]['jexid'] = \
+                    self.excp_id
+
+        self.data['jscid'] = str(self.schedule_id)
+
+        if self.is_positive_test:
+            response = schedules_utils.api_put(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+        else:
+            if self.mocking_required:
+                with patch(self.mock_data["function_name"],
+                           side_effect=[eval(self.mock_data["return_value"])]):
+                    response = pgagent_utils.api_put(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+            utils.assert_error_message(self, response)
+
+    def tearDown(self):
+        """Clean up code"""
+        pgagent_utils.delete_pgagent_schedule(self)
+        pgagent_utils.delete_pgagent_job(self)
diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/schedules/tests/utils.py b/web/pgadmin/browser/server_groups/servers/pgagent/schedules/tests/utils.py
new file mode 100644
index 000000000..3a2e14c49
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/schedules/tests/utils.py
@@ -0,0 +1,62 @@
+import sys
+import traceback
+import os
+import json
+from urllib.parse import urlencode
+
+from regression.python_test_utils import test_utils as utils
+
+# Load test data from json file.
+CURRENT_PATH = os.path.dirname(os.path.realpath(__file__))
+with open(CURRENT_PATH + "/schedules_test_data.json") as data_file:
+    test_cases = json.load(data_file)
+
+
+# api methods
+def api_create(self):
+    return self.tester.post('{0}{1}/{2}/{3}/'.
+                            format(self.url, utils.SERVER_GROUP,
+                                   self.server_id, self.job_id),
+                            data=json.dumps(self.data),
+                            content_type='html/json')
+
+
+def api_delete(self, schedule_id=None):
+    if schedule_id is None:
+        schedule_id = self.schedule_id
+    return self.tester.delete('{0}{1}/{2}/{3}/{4}'.
+                              format(self.url, utils.SERVER_GROUP,
+                                     self.server_id, self.job_id,
+                                     schedule_id),
+                              data=json.dumps(self.data),
+                              content_type='html/json')
+
+
+def api_put(self):
+    return self.tester.put('{0}{1}/{2}/{3}/{4}'.
+                           format(self.url, utils.SERVER_GROUP, self.server_id,
+                                  self.job_id, self.schedule_id),
+                           data=json.dumps(self.data),
+                           content_type='html/json')
+
+
+def api_get(self, schedule_id=None):
+    if schedule_id is None:
+        schedule_id = self.schedule_id
+    return self.tester.get('{0}{1}/{2}/{3}/{4}'.
+                           format(self.url, utils.SERVER_GROUP,
+                                  self.server_id, self.job_id,
+                                  schedule_id),
+                           content_type='html/json')
+
+
+def api_get_msql(self, url_encode_data, schedule_id=None):
+    if schedule_id is None:
+        schedule_id = '/' + str(self.schedule_id)
+    return self.tester.get("{0}{1}/{2}/{3}{4}?{5}".
+                           format(self.url, utils.SERVER_GROUP,
+                                  self.server_id, self.job_id,
+                                  schedule_id,
+                                  urlencode(url_encode_data)),
+                           data=json.dumps(self.data),
+                           follow_redirects=True)
diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/steps/tests/test_pgagent_add_steps.py b/web/pgadmin/browser/server_groups/servers/pgagent/steps/tests/test_pgagent_add_steps.py
new file mode 100644
index 000000000..328da63f1
--- /dev/null
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/steps/tests/test_pgagent_add_steps.py
@@ -0,0 +1,70 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+from unittest.mock import patch
+
+import simplejson as json
+import uuid
+from pgadmin.utils.route import BaseTestGenerator
+from regression.python_test_utils import test_utils as utils
+from pgadmin.browser.server_groups.servers.pgagent.tests import utils as \
+    pgagent_utils
+from . import utils as steps_utils
+
+
+class PgAgentAddStepTestCase(BaseTestGenerator):
+    """This class will test the add step in the pgAgent job API"""
+    scenarios = utils.generate_scenarios("pgagent_create_step",
+                                         steps_utils.test_cases)
+
+    def setUp(self):
+        flag, msg = pgagent_utils.is_valid_server_to_run_pgagent(self)
+        if not flag:
+            self.skipTest(msg)
+        flag, msg = pgagent_utils.is_pgagent_installed_on_server(self)
+        if not flag:
+            self.skipTest(msg)
+
+        # Load test data
+        self.data = self.test_data
+
+        # Create job
+        name = "test_job_get%s" % str(uuid.uuid4())[1:8]
+        self.job_id = pgagent_utils.create_pgagent_job(self, name)
+
+    def runTest(self):
+        self.pgagent_step_name = "test_step_add%s" % str(uuid.uuid4())[1:8]
+        self.data["jstjobid"] = self.job_id
+        self.data["jstname"] = self.pgagent_step_name
+
+        if self.is_positive_test:
+            response = steps_utils.api_create(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+
+            # Verify in backend
+            response_data = json.loads(response.data)
+            self.step_id = response_data['node']['_id']
+            is_present = pgagent_utils.verify_pgagent_step(self)
+            self.assertTrue(is_present,
+                            "pgAgent step was not created successfully.")
+
+        else:
+            if self.mocking_required:
+                with patch(self.mock_data["function_name"],
+                           side_effect=eval(self.mock_data["return_value"])):
+                    response = steps_utils.api_create(self)
+
+                    # Assert response
+                    utils.assert_status_code(self, response)
+                    utils.assert_error_message(self, response)
+
+    def tearDown(self):
+        """Clean up code"""
+        pgagent_utils.delete_pgagent_job(self)
diff --git a/web/pgadmin/browser/server_groups/servers/pgagent/tests/tests_pgagent_delete_steps.py b/web/pgadmin/browser/server_groups/servers/pgagent/steps/tests/test_pgagent_delete_steps.py
similarity index 61%
rename from web/pgadmin/browser/server_groups/servers/pgagent/tests/tests_pgagent_delete_steps.py
rename to web/pgadmin/browser/server_groups/servers/pgagent/steps/tests/test_pgagent_delete_steps.py
index 20cb83552..97bb2c5d4 100644
--- a/web/pgadmin/browser/server_groups/servers/pgagent/tests/tests_pgagent_delete_steps.py
+++ b/web/pgadmin/browser/server_groups/servers/pgagent/steps/tests/test_pgagent_delete_steps.py
@@ -10,14 +10,15 @@
 import uuid
 from pgadmin.utils.route import BaseTestGenerator
 from regression.python_test_utils import test_utils as utils
-from . import utils as pgagent_utils
+from pgadmin.browser.server_groups.servers.pgagent.tests import utils as \
+    pgagent_utils
+from . import utils as steps_utils
 
 
 class PgAgentDeleteStepTestCase(BaseTestGenerator):
     """This class will test the delete pgAgent job step API"""
-    scenarios = [
-        ('Delete pgAgent Step', dict(url='/browser/pga_jobstep/obj/'))
-    ]
+    scenarios = utils.generate_scenarios("pgagent_delete_step",
+                                         steps_utils.test_cases)
 
     def setUp(self):
         flag, msg = pgagent_utils.is_valid_server_to_run_pgagent(self)
@@ -26,26 +27,37 @@ class PgAgentDeleteStepTestCase(BaseTestGenerator):
         flag, msg = pgagent_utils.is_pgagent_installed_on_server(self)
         if not flag:
             self.skipTest(msg)
+
+        # Load test data
+        self.data = self.test_data
+
         name = "test_job_delete%s" % str(uuid.uuid4())[1:8]
         self.job_id = pgagent_utils.create_pgagent_job(self, name)
+
         step_name = "test_step_delete%s" % str(uuid.uuid4())[1:8]
         self.step_id = pgagent_utils.create_pgagent_step(
             self, step_name, self.job_id)
 
+        if self.is_list:
+            step_name_2 = "test_step_delete%s" % str(uuid.uuid4())[1:8]
+            self.step_id_2 = pgagent_utils.create_pgagent_step(
+                self, step_name_2, self.job_id)
+
     def runTest(self):
         """This function will deletes pgAgent job step"""
-        response = self.tester.delete(
-            '{0}{1}/{2}/{3}/{4}'.format(
-                self.url, str(utils.SERVER_GROUP), str(self.server_id),
-                str(self.job_id), str(self.step_id)
-            ),
-            content_type='html/json'
-        )
-        self.assertEqual(response.status_code, 200)
+        if self.is_positive_test:
+            if self.is_list:
+                self.data['ids'] = [self.step_id, self.step_id_2]
+                response = steps_utils.api_delete(self, '')
+            else:
+                response = steps_utils.api_delete(self)
+
+            # Assert response
+            utils.assert_status_code(self, response)
+
         is_present = pgagent_utils.verify_pgagent_step(self)
         self.assertFalse(
-            is_present, "pgAgent step was not deleted successfully"
-        )
+            is_present, "pgAgent step was not deleted successfully")
 
     def tearDown(self):
         """Clean up code"""
